Index: /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isftbl.F90
===================================================================
--- /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isftbl.F90	(revision 11402)
+++ /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isftbl.F90	(revision 11403)
@@ -1,32 +1,43 @@
 MODULE isftbl
-
-USE in_out_manager
-USE dom_oce
-USE oce
-USE isf
-USE lbclnk
-
-IMPLICIT NONE
-
-PRIVATE
-
-PUBLIC isf_tbl, isf_tbl_avg, isf_tbl_lvl, isftbl_ktop, isftbl_kbot
+   !!======================================================================
+   !!                       ***  MODULE  isftbl  ***
+   !! isftbl module :  compute properties of top boundary layer
+   !!======================================================================
+   !! History :  4.1  !  2019-09  (P. Mathiot) original code
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   isftbl       : routine to compute : 
+   !!                  - geometry of the ice shelf tbl (isf_tbl_lvl, isftbl_ktop, isftbl_kbot)
+   !!                    (top and bottom level, thickness and fraction of deepest level affected)
+   !!                  - tbl averaged properties (isf_tbl, isf_tbl_avg)
+   !!----------------------------------------------------------------------
+
+   USE dom_oce ! vertical scale factor
+   USE lbclnk  ! lbc_lnk subroutine
+
+   IMPLICIT NONE
+
+   PRIVATE
+
+   PUBLIC isf_tbl, isf_tbl_avg, isf_tbl_lvl, isftbl_ktop, isftbl_kbot
 
 CONTAINS
 
    SUBROUTINE isf_tbl( pvarin, pvarout, cd_ptin, ktop, kbot, phtbl, pfrac )
-      !!----------------------------------------------------------------------
-      !!                  ***  SUBROUTINE sbc_isf_tbl  ***
+      !!--------------------------------------------------------------------
+      !!                  ***  SUBROUTINE isf_tbl  ***
       !!
       !! ** Purpose : compute mean T/S/U/V in the boundary layer at T- point
       !!
-      !!----------------------------------------------------------------------
-      !!-------------------------- OUT -------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(  out) :: pvarout ! 2d average of pvarin
-      !!-------------------------- IN  -------------------------------------
-      CHARACTER(len=1),                       INTENT(in   ) :: cd_ptin ! point of variable in/out
-      INTEGER,  DIMENSION(jpi,jpj), OPTIONAL, INTENT(in   ) :: ktop , kbot
-      REAL(wp), DIMENSION(jpi,jpj), OPTIONAL, INTENT(in   ) :: phtbl, pfrac
-      REAL(wp), DIMENSION(jpi,jpj,jpk),       INTENT(in   ) :: pvarin  ! 3d variable to average over the tbl
+      !!--------------------------------------------------------------------
+      !!-------------------------- OUT -------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj)          , INTENT(  out) :: pvarout ! 2d average of pvarin
+      !!-------------------------- IN  -------------------------------------
+      CHARACTER(len=1)                      , INTENT(in   ) :: cd_ptin       ! point of variable in/out
+      REAL(wp), DIMENSION(jpi,jpj,jpk)      , INTENT(in   ) :: pvarin        ! 3d variable to average over the tbl
+      !!-------------------------- IN OPTIONAL -----------------------------
+      INTEGER,  DIMENSION(jpi,jpj), OPTIONAL, INTENT(in   ) :: ktop , kbot   ! top and bottom level
+      REAL(wp), DIMENSION(jpi,jpj), OPTIONAL, INTENT(in   ) :: phtbl, pfrac  ! tbl thickness and fraction of bottom cell affected
       !!--------------------------------------------------------------------
       INTEGER ::   ji, jj                   ! loop index
@@ -34,5 +45,5 @@
       REAL(wp), DIMENSION(jpi,jpj) :: zhtbl ! thickness of the tbl
       REAL(wp), DIMENSION(jpi,jpj) :: zfrac ! thickness of the tbl
-      !!----------------------------------------------------------------------
+      !!--------------------------------------------------------------------
       ! 
       SELECT CASE ( cd_ptin )
@@ -86,21 +97,24 @@
 
    SUBROUTINE isf_tbl_avg( ktop, kbot, phtbl, pfrac, pe3, pvarin, pvarout )
-      !!---------------------------------------------------------------------
+      !!--------------------------------------------------------------------
       !!                  ***  ROUTINE isf_tbl_lvl  ***
       !!
       !! ** Purpose : compute mean property in the boundary layer
       !!
-      !!----------------------------------------------------------------------
-      !!-------------------------- OUT -------------------------------------
-      REAL(wp), DIMENSION(:,:)  , INTENT(  out) :: pvarout
-      !!-------------------------- IN  -------------------------------------
-      INTEGER,  DIMENSION(jpi,jpj), INTENT(in) :: ktop, kbot   ! top and bottom level of the top boundary layer
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: phtbl, pfrac !! fraction of bottom level of the tbl to be affected by the tbl
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) :: pe3      ! vertical scale factor
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) :: pvarin   ! tbl property to average between ktop, kbot over phtbl
-      !!---------------------------------------------------------------------
+      !! ** Method  : Depth average is made between the top level ktop and the bottom level kbot
+      !!              over a thickness phtbl. The bottom level is partially counted (pfrac).
+      !!
+      !!--------------------------------------------------------------------
+      !!-------------------------- OUT -------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(  out) :: pvarout      ! tbl property averaged over phtbl between level ktop and kbot
+      !!-------------------------- IN  -------------------------------------
+      INTEGER,  DIMENSION(jpi,jpj)    , INTENT(in   ) :: ktop, kbot   ! top and bottom level of the top boundary layer
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(in   ) :: phtbl, pfrac ! fraction of bottom level to be affected by the tbl
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) :: pe3          ! vertical scale factor
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) :: pvarin       ! tbl property to average between ktop, kbot over phtbl
+      !!--------------------------------------------------------------------
       INTEGER  :: ji,jj,jk                    ! loop indices
       INTEGER  :: ikt, ikb                    ! top and bottom levels
-      !!---------------------------------------------------------------------
+      !!--------------------------------------------------------------------
       !
       ! compute tbl top.bottom level and thickness
@@ -123,5 +137,5 @@
 
    SUBROUTINE isf_tbl_lvl( phw, pe3, ktop, kbot, phtbl, pfrac )
-      !!---------------------------------------------------------------------
+      !!--------------------------------------------------------------------
       !!                  ***  ROUTINE isf_tbl_lvl  ***
       !!
@@ -129,13 +143,13 @@
       !!              - thickness of the top boundary layer
       !!
-      !!----------------------------------------------------------------------
-      !!-------------------------- OUT -------------------------------------
-      INTEGER,  DIMENSION(jpi,jpj), INTENT(inout) :: kbot         ! bottom level of the top boundary layer
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: phtbl        ! top boundary layer thickness
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pfrac        ! top boundary layer thickness
-      !!-------------------------- IN  -------------------------------------
-      INTEGER,  DIMENSION(jpi,jpj)    , INTENT(in) :: ktop       ! top level of the top boundary layer
-      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(in) :: phw        ! water column thickness
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) :: pe3         ! vertical scale factor
+      !!--------------------------------------------------------------------
+      !!-------------------------- OUT -------------------------------------
+      INTEGER,  DIMENSION(jpi,jpj)    , INTENT(  out) :: kbot   ! bottom level of the top boundary layer
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(  out) :: phtbl  ! top boundary layer thickness
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(  out) :: pfrac  ! top boundary layer thickness
+      !!-------------------------- IN  -------------------------------------
+      INTEGER,  DIMENSION(jpi,jpj)    , INTENT(in   ) :: ktop   ! top level of the top boundary layer
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(in   ) :: phw    ! water column thickness
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) :: pe3    ! vertical scale factor
       !!---------------------------------------------------------------------
       INTEGER :: ji,jj,jk
@@ -178,18 +192,25 @@
    !
    SUBROUTINE isftbl_kbot(ktop, phtbl, pe3, kbot)
-      !!-------------------------- OUT -------------------------------------
-      INTEGER,  DIMENSION(jpi,jpj), INTENT(inout) :: kbot         ! bottom level of the top boundary layer
-      !!-------------------------- IN  -------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: phtbl           ! top boundary layer thickness
-      INTEGER,  DIMENSION(jpi,jpj), INTENT(in) :: ktop            ! top level of the top boundary layer
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) :: pe3         ! vertical scale factor
-      !!---------------------------------------------------------------------
+      !!--------------------------------------------------------------------
+      !!                  ***  ROUTINE isf_tbl_lvl  ***
+      !!
+      !! ** Purpose : compute bottom level of the isf top boundary layer
+      !!
+      !!--------------------------------------------------------------------
+      !!-------------------------- OUT -------------------------------------
+      INTEGER,  DIMENSION(jpi,jpj)    , INTENT(  out) :: kbot   ! bottom level of the top boundary layer
+      !!-------------------------- IN  -------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(in   ) :: phtbl  ! top boundary layer thickness
+      INTEGER,  DIMENSION(jpi,jpj)    , INTENT(in   ) :: ktop   ! top level of the top boundary layer
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) :: pe3    ! vertical scale factor
+      !!--------------------------------------------------------------------
       INTEGER :: ji, jj
       INTEGER :: ikt, ikb
-      !!---------------------------------------------------------------------
+      !!--------------------------------------------------------------------
       !
       ! phtbl need to be bounded by water column thickness before
       ! test: if phtbl = water column thickness, should return mbathy
       ! test: if phtbl = 0 should return ktop
+      !
       ! get ktbl
       DO jj = 1,jpj
@@ -208,22 +229,24 @@
       !
    SUBROUTINE isftbl_ktop(pdep, ktop)
-      !!---------------------------------------------------------------------
+      !!--------------------------------------------------------------------
       !!                  ***  ROUTINE isf_tbl_lvl  ***
       !!
       !! ** Purpose : compute top level of the isf top boundary layer in case of an ice shelf parametrisation
       !!
-      !!----------------------------------------------------------------------
-      !!-------------------------- OUT -------------------------------------
-      INTEGER,  DIMENSION(jpi,jpj), INTENT(inout) :: ktop         ! top level affected by the ice shelf parametrisation
-      !!-------------------------- IN  -------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: pdep            ! top depth of the parametrisation influence
-      !!---------------------------------------------------------------------
+      !!--------------------------------------------------------------------
+      !!-------------------------- OUT -------------------------------------
+      INTEGER,  DIMENSION(jpi,jpj), INTENT(  out) :: ktop        ! top level affected by the ice shelf parametrisation
+      !!-------------------------- IN  -------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: pdep        ! top depth of the parametrisation influence
+      !!--------------------------------------------------------------------
       INTEGER :: ji,jj
       INTEGER :: ikt
-      !!---------------------------------------------------------------------
+      !!--------------------------------------------------------------------
+      !
       ! compute top level (need to be recomputed each time (z*, z~) 
       ! be sure pdep is already correctly bounded
       ! test: this routine run on isfdraft should return mikt
       ! test: this routine run with pdep = 0 should return 1
+      !
       DO ji = 1, jpi
          DO jj = 1, jpj
@@ -234,5 +257,5 @@
       END DO
       !
-   END SUBROUTINE
+   END SUBROUTINE isftbl_ktop
 
 END MODULE isftbl
Index: /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfutils.F90
===================================================================
--- /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfutils.F90	(revision 11402)
+++ /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfutils.F90	(revision 11403)
@@ -1,35 +1,45 @@
 MODULE isfutils
+   !!======================================================================
+   !!                       ***  MODULE  isfutils  ***
+   !! istutils module : miscelenious useful routines
+   !!======================================================================
+   !! History :  4.1  !  2019-09  (P. Mathiot) original code
+   !!----------------------------------------------------------------------
 
-USE oce
-USE in_out_manager
-USE iom
-USE lib_fortran
-USE lib_mpp
+   !!----------------------------------------------------------------------
+   !!   isfutils       : - read_2dcstdta to read a constant input file with iom_get
+   !!                    - debug to print array sum, min, max in ocean.output
+   !!----------------------------------------------------------------------
 
-IMPLICIT NONE
+   USE iom
+   USE lib_fortran
+   USE lib_mpp
 
-PRIVATE
+   IMPLICIT NONE
 
-INTERFACE isf_debug
-   MODULE PROCEDURE isf_debug2d, isf_debug3d
-END INTERFACE isf_debug
+   PRIVATE
 
-PUBLIC read_2dcstdta, isf_debug
+   INTERFACE debug
+      MODULE PROCEDURE debug2d, debug3d
+   END INTERFACE debug
+
+   PUBLIC read_2dcstdta, debug
 
 CONTAINS
 
    SUBROUTINE read_2dcstdta(cdfile, cdvar, pvar)
-      !!---------------------------------------------------------------------
+      !!--------------------------------------------------------------------
       !!                  ***  ROUTINE read_2dcstdta  ***
       !!
       !! ** Purpose : read input file
       !!
-      !!----------------------------------------------------------------------
+      !!--------------------------------------------------------------------
       !!-------------------------- OUT -------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pvar
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(  out) :: pvar          ! output variable
       !!-------------------------- IN  -------------------------------------
-      CHARACTER(len=256), INTENT(in) :: cdfile, cdvar
+      CHARACTER(len=256)          , INTENT(in   ) :: cdfile, cdvar ! input file name and variable name
       !!--------------------------------------------------------------------
       INTEGER :: inum
+      !!--------------------------------------------------------------------
 
       CALL iom_open( cdfile, inum )
@@ -39,25 +49,52 @@
    END SUBROUTINE read_2dcstdta
 
-   SUBROUTINE isf_debug2d(cdtxt,pvar)
-      CHARACTER(LEN=256), INTENT(in) :: cdtxt
+   SUBROUTINE debug2d(cdtxt,pvar)
+      !!--------------------------------------------------------------------
+      !!                  ***  ROUTINE isf_debug2d  ***
+      !!
+      !! ** Purpose : add debug print
+      !!
+      !!--------------------------------------------------------------------
+      !!-------------------------- OUT -------------------------------------
+      !!-------------------------- IN  -------------------------------------
+      CHARACTER(LEN=256)          , INTENT(in   ) :: cdtxt
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: pvar
+      !!--------------------------------------------------------------------
       REAL(wp) :: zmin, zmax, zsum
-      zsum = glob_sum( 'isf_debug', pvar(:,:) )
-      zmin = MINVAL( pvar(:,:) ) ; CALL mpp_min( 'isf_debug', zmin ) ! min over the global domain
-      zmax = MAXVAL( pvar(:,:) ) ; CALL mpp_max( 'isf_debug', zmax ) ! max over the global domain
+      !!--------------------------------------------------------------------
+      !
+      zsum = glob_sum( 'debug', pvar(:,:) )
+      zmin = MINVAL( pvar(:,:) ) ; CALL mpp_min( 'debug', zmin ) ! min over the global domain
+      zmax = MAXVAL( pvar(:,:) ) ; CALL mpp_max( 'debug', zmax ) ! max over the global domain
+      !
       WRITE(numout,*) TRIM(cdtxt),' (min, max, sum) : ',zmin, zmax, zsum
+      !
       FLUSH(numout)
-   END SUBROUTINE isf_debug2d
+   END SUBROUTINE debug2d
 
-   SUBROUTINE isf_debug3d(cdtxt,pvar)
-      CHARACTER(LEN=256), INTENT(in) :: cdtxt
+   SUBROUTINE debug3d(cdtxt,pvar)
+      !!--------------------------------------------------------------------
+      !!                  ***  ROUTINE isf_debug3d  ***
+      !!
+      !! ** Purpose : add debug print
+      !!
+      !!--------------------------------------------------------------------
+      !!-------------------------- OUT -------------------------------------
+      !!-------------------------- IN  -------------------------------------
+      CHARACTER(LEN=256)              , INTENT(in   ) :: cdtxt
       REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) :: pvar
+      !!--------------------------------------------------------------------
       REAL(wp) :: zmin, zmax, zsum
-      zsum = glob_sum( 'isf_debug', pvar(:,:) )
-      zmin = MINVAL( pvar(:,:) ) ; CALL mpp_min( 'isf_debug', zmin ) ! min over the global domain
-      zmax = MAXVAL( pvar(:,:) ) ; CALL mpp_max( 'isf_debug', zmax ) ! max over the global domain
+      !!--------------------------------------------------------------------
+      !
+      zsum = glob_sum( 'debug', pvar(:,:) )
+      zmin = MINVAL( pvar(:,:) ) ; CALL mpp_min( 'debug', zmin ) ! min over the global domain
+      zmax = MAXVAL( pvar(:,:) ) ; CALL mpp_max( 'debug', zmax ) ! max over the global domain
+      !
       WRITE(numout,*) TRIM(cdtxt),' (min, max, sum) : ',zmin, zmax, zsum
+      !
       FLUSH(numout)
-   END SUBROUTINE isf_debug3d
+      !
+   END SUBROUTINE debug3d
 
 END MODULE isfutils
Index: /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/SBC/sbccpl.F90
===================================================================
--- /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/SBC/sbccpl.F90	(revision 11402)
+++ /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/SBC/sbccpl.F90	(revision 11403)
@@ -36,5 +36,5 @@
    USE eosbn2         ! 
    USE sbcrnf  , ONLY : l_rnfcpl
-   USE isf     , ONLY : l_isfcpl, fwfisf_cav, fwfisf_par
+   USE isf     , ONLY : l_isfcpl, fwfisf_cpl
 #if defined key_cice
    USE ice_domain_size, only: ncat
@@ -1406,5 +1406,9 @@
              rnf(:,:)    = rnf(:,:) + fwficb(:,:)   ! iceberg added to runfofs
          ENDIF
-         IF( srcv(jpr_isf)%laction )  fwfisf_par(:,:) = - frcv(jpr_isf)%z3(:,:,1)  ! fresh water flux from the isf (fwfisf <0 mean melting)  
+         !
+         ! ice shelf fwf
+         IF( srcv(jpr_isf)%laction )  THEN
+            fwfisf_cpl(:,:) = - frcv(jpr_isf)%z3(:,:,1)  ! fresh water flux from the isf (fwfisf <0 mean melting)  
+         END IF
         
          IF( ln_mixcpl ) THEN   ;   emp(:,:) = emp(:,:) * xcplmask(:,:,0) + zemp(:,:) * zmsk(:,:)
@@ -1709,5 +1713,5 @@
       ENDIF
       IF( srcv(jpr_isf)%laction ) THEN   ! iceshelf (fwfisf <0 mean melting)
-        fwfisf_par(:,:) = - frcv(jpr_isf)%z3(:,:,1)  
+        fwfisf_cpl(:,:) = - frcv(jpr_isf)%z3(:,:,1)  
       ENDIF
 
@@ -1748,5 +1752,5 @@
       ENDIF
       IF( srcv(jpr_isf)%laction ) THEN   ! iceshelf (fwfisf <0 mean melting)
-        fwfisf_par(:,:) = - frcv(jpr_isf)%z3(:,:,1)
+        fwfisf_cpl(:,:) = - frcv(jpr_isf)%z3(:,:,1)
       ENDIF
       !
Index: /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/TRA/traisf.F90
===================================================================
--- /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/TRA/traisf.F90	(revision 11402)
+++ /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/TRA/traisf.F90	(revision 11403)
@@ -1,6 +1,6 @@
 MODULE traisf
    !!==============================================================================
-   !!                       ***  MODULE  trasbc  ***
-   !! Ocean active tracers:  surface boundary condition
+   !!                       ***  MODULE  traisf  ***
+   !! Ocean active tracers:  ice shelf boundary condition
    !!==============================================================================
    !! History :    4.0  !  2019-09  (P. Mathiot) original file
@@ -38,22 +38,9 @@
    SUBROUTINE tra_isf ( kt )
       !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE tra_sbc  ***
+      !!                  ***  ROUTINE tra_isf  ***
       !!                   
-      !! ** Purpose :   Compute the tracer surface boundary condition trend of
-      !!      (flux through the interface, concentration/dilution effect)
-      !!      and add it to the general trend of tracer equations.
+      !! ** Purpose :  Compute the temperature trend due to the ice shelf melting (qhoce + qhc)
       !!
-      !! ** Method :   The (air+ice)-sea flux has two components: 
-      !!      (1) Fext, external forcing (i.e. flux through the (air+ice)-sea interface); 
-      !!      (2) Fwe , tracer carried with the water that is exchanged with air+ice. 
-      !!               The input forcing fields (emp, rnf, sfx, isf) contain Fext+Fwe,
-      !!             they are simply added to the tracer trend (tsa).
-      !!               In linear free surface case (ln_linssh=T), the volume of the
-      !!             ocean does not change with the water exchanges at the (air+ice)-sea
-      !!             interface. Therefore another term has to be added, to mimic the
-      !!             concentration/dilution effect associated with water exchanges.
-      !!
-      !! ** Action  : - Update tsa with the surface boundary condition trend 
-      !!              - send trends to trdtra module for further diagnostics(l_trdtra=T)
+      !! ** Action  : - update tsa for cav, par and cpl case
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
@@ -62,11 +49,11 @@
       IF( ln_timing )   CALL timing_start('tra_sbc')
       !
-      !----------------------------------------
-      !       Ice Shelf effects (ISF)
-      !     tbl treated as in Losh (2008) JGR
-      !----------------------------------------
+      ! cavity case
       IF ( ln_isfcav_mlt ) CALL tra_isf_mlt(misfkt_cav, misfkb_cav, rhisf_tbl_cav, rfrac_tbl_cav, risf_cav_tsc, risf_cav_tsc_b, tsa)
+      !
+      ! parametrisation case
       IF ( ln_isfpar_mlt ) CALL tra_isf_mlt(misfkt_par, misfkb_par, rhisf_tbl_par, rfrac_tbl_par, risf_par_tsc, risf_par_tsc_b, tsa)
       !
+      ! ice sheet coupling case
       !CALL tra_isf_cpl()
       !
@@ -77,4 +64,11 @@
    SUBROUTINE tra_isf_mlt(ktop, kbot, phtbl, pfrac, ptsc, ptsc_b, pts)
       !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_isf_mlt  ***
+      !!
+      !! *** Purpose :  Compute the temperature trend due to the ice shelf melting (qhoce + qhc) for cav or par case
+      !!
+      !! *** Action :: Update tsa with the surface boundary condition trend 
+      !!
+      !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(inout) :: pts
       !!----------------------------------------------------------------------
@@ -82,17 +76,11 @@
       REAL(wp), DIMENSION(jpi,jpj)     , INTENT(in   ) :: phtbl, pfrac
       REAL(wp), DIMENSION(jpi,jpj,jpts), INTENT(in   ) :: ptsc , ptsc_b
+      REAL(wp), DIMENSION(jpi,jpj) :: ztc
+      !!----------------------------------------------------------------------
+      INTEGER                      :: ji,jj,jk  ! loop index   
+      INTEGER                      :: ikt, ikb  ! top and bottom level of the tbl
+      REAL(wp), DIMENSION(jpi,jpj) :: ztc       ! total ice shelf tracer trend
       !!----------------------------------------------------------------------
       !
-      INTEGER  ::   ji, jj, jk, jn              ! dummy loop indices  
-      INTEGER  ::   ikt, ikb                    ! local integers
-      REAL(wp) :: zeps = 1.e-20
-      REAL(wp), DIMENSION(jpi,jpj) :: ztc
-      !!----------------------------------------------------------------------
-      !
-      !----------------------------------------
-      !       Ice Shelf effects (ISF)
-      !     tbl treated as in Losh (2008) JGR
-      !----------------------------------------
-      ! 
       ! compute 2d total trend due to isf
       ztc(:,:) = 0.5_wp * ( ptsc(:,:,jp_tem) + ptsc_b(:,:,jp_tem) ) / phtbl(:,:)
Index: /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/TRA/tranxt.F90
===================================================================
--- /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/TRA/tranxt.F90	(revision 11402)
+++ /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/TRA/tranxt.F90	(revision 11403)
@@ -316,4 +316,6 @@
                      ztc_f  = ztc_f  - zfact1 * ( psbc_tc(ji,jj,jn) - psbc_tc_b(ji,jj,jn) )
                   ENDIF
+                  !
+                  ! river runoff
                   IF( ln_rnf_depth ) THEN
                      ! Rivers are not just at the surface must go down to nk_rnf(ji,jj)
@@ -327,15 +329,13 @@
                      ENDIF
                   ENDIF
-
+                  !
+                  IF( ll_rnf .AND. jk <= nk_rnf(ji,jj) )                                          &
+                     &     ztc_f  = ztc_f  - zfact1 * ( rnf_tsc(ji,jj,jn) - rnf_tsc_b(ji,jj,jn) ) & 
+                     &                              * e3t_n(ji,jj,jk) / h_rnf(ji,jj)
                   !
                   ! solar penetration (temperature only)
                   IF( ll_traqsr .AND. jn == jp_tem .AND. jk <= nksr )                            & 
                      &     ztc_f  = ztc_f  - zfact1 * ( qsr_hc(ji,jj,jk) - qsr_hc_b(ji,jj,jk) ) 
-                     !
-                  ! river runoff
-                  IF( ll_rnf .AND. jk <= nk_rnf(ji,jj) )                                          &
-                     &     ztc_f  = ztc_f  - zfact1 * ( rnf_tsc(ji,jj,jn) - rnf_tsc_b(ji,jj,jn) ) & 
-                     &                              * e3t_n(ji,jj,jk) / h_rnf(ji,jj)
-                     !
+                  !
                   ! ice shelf
                   IF( ll_isf ) THEN
Index: /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/nemogcm.F90
===================================================================
--- /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/nemogcm.F90	(revision 11402)
+++ /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/nemogcm.F90	(revision 11403)
@@ -60,5 +60,5 @@
    USE diacfl         ! CFL diagnostics               (dia_cfl_init routine)
    USE step           ! NEMO time-stepping                 (stp     routine)
-   USE isfmlt         ! ice shelf                     (isf_mlt_init routine)
+   USE isfstp         ! ice shelf                     (isf_stp_init routine)
    USE icbini         ! handle bergs, initialisation
    USE icbstp         ! handle bergs, calving, themodynamics and transport
@@ -453,5 +453,5 @@
       !                                      ! Active tracers
       IF( ln_traqsr    )   CALL tra_qsr_init      ! penetrative solar radiation qsr
-      IF (ln_isf       )   CALL isf_mlt_init      ! ice shelf
+                           CALL isf_stp_init      ! ice shelf
                            CALL tra_bbc_init      ! bottom heat flux
                            CALL tra_bbl_init      ! advective (and/or diffusive) bottom boundary layer scheme
Index: /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/step.F90
===================================================================
--- /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/step.F90	(revision 11402)
+++ /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/step.F90	(revision 11403)
@@ -113,5 +113,5 @@
       IF( ln_apr_dyn )   CALL sbc_apr ( kstp )                   ! atmospheric pressure (NB: call before bdy_dta which needs ssh_ib) 
       IF( ln_bdy     )   CALL bdy_dta ( kstp, time_offset=+1 )   ! update dynamic & tracer data at open boundaries
-      IF( ln_isf     )   CALL isf_mlt ( kstp )
+      IF( ln_isf     )   CALL isf_stp ( kstp )
                          CALL sbc     ( kstp )                   ! Sea Boundary Condition (including sea-ice)
 
Index: /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/step_oce.F90
===================================================================
--- /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/step_oce.F90	(revision 11402)
+++ /NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/step_oce.F90	(revision 11403)
@@ -22,5 +22,5 @@
    USE sbcwave         ! Wave intialisation
 
-   USE isfmlt          ! ice shelf boundary condition     (isf_mlt routine)
+   USE isfstp          ! ice shelf boundary condition     (isf_stp routine)
 
    USE traqsr          ! solar radiation penetration      (tra_qsr routine)
